#!/usr/bin/perl

#==============================================================================================================
#    ,  gcomp -d -v,   /
#  / .
#==============================================================================================================
#    stdin log  gcomp -v,       ( 'NEW:'),
#      cvs add.    ( 'DEL:')  
# cvs remove.
#         stdout.
#
#  gcomp  log  OEM ,        
# .  :
# \>gcomp -d -v | recode.exe -aw - | perl c:\Script\auto_add.pl >>log
#
#  cvs commit    -    .
#==============================================================================================================

$session_splitter = "-------------------------------------------------------------------------------------------------\n";
foreach $line (<STDIN>)
{
	($cvs_cmd, $info) = ParseLine();
	if( $cvs_cmd )
	{
		SessionStart();

		($work_dir, $path) = SplitPath($line);
		chdir $work_dir;
		AddParentDirs("$path") if $cvs_cmd eq "add";
		print "$info File: $path\n";
		print STDERR "$info File: $path\n";
		$path =~ s/\\/\\\\/g;
		DoCommand("cvs $cvs_cmd $path");
		chdir "..";
	}
	else
	{
		print STDERR $line, "\n";
	}	
}
SessionEnd();


sub ParseLine
{
	$line =~ s/[\r\n]//g; #  \n  \r,    

	if( $line =~ s/^NEW:\s*'*(.+)'*\s*$/$1/ )
	{
		return ("add", "ADD");
	}
	elsif( $line =~ s/^DEL:\s*'*(.+)'*\s*$/$1/ )
	{
		return ("remove", "DEL");
	}
	return ("", "");
}
	  
sub SplitPath
{
	my $path = shift;
	$path =~ m/^([^\\]*)\\+(.*)$/;
	return ("$1", "$2");
}

sub AddParentDirs
{
	my $dir = shift;
	my $i = 0;
	my @dir_list;

	while( $dir =~ s/(.*)\\([^\\]*)/$1/ )
	{
		$dir_list[$i++] = "$dir" unless -d "$dir\\CVS" or -d "$dir\\cvs";
	}

	while( --$i >= 0 )
	{
		$dir = $dir_list[$i];
		print "ADD Dir: $dir\n";
		print STDERR "ADD Dir: $dir\n";
		$dir =~ s/\\/\\\\/g; #- cvs ,      2 
		DoCommand("cvs add $dir");
	}
}

sub DoCommand
{
	my $cmd = shift;
	my $line;
	open(CMD, "$cmd 2>&1 |");
	foreach $line (<CMD>)
	{
		print "\t", $line; #,   cvs,     
	}
	close CMD;
}

sub SessionStart
{
	if( not $time_printed )
	{
		($sec, $min, $hour, $mday, $mon, $year) = localtime();
		$year += 1900;
		$mon++;
		printf "%04i.%02i.%02i %02i:%02i:%02i\n", $year, $mon, $mday, $hour, $min, $sec;
		print $session_splitter;
		$time_printed = 1;
	}
}	

sub SessionEnd
{
	print $session_splitter, "\n" if $time_printed;
}	
